#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "brush.h"
#include "editface.h"
#include "edvert.h"
#include "game.h"
#include "quest.h"
#include "undo.h"


/* TODO: move EditFace() to own file */
static void C_face_edit(void)
{
   SUndo(UNDO_NONE,UNDO_CHANGE);
   EditFace();
   Cmd_SetRedraw(2);
}

/* TODO: have games add this command themselves? */
static void C_face_flags(void)
{
   SUndo(UNDO_NONE,UNDO_CHANGE);
   if (Game.tex.settexdef)
      Game.tex.settexdef();
}


static cmd_reg_t face_cmds[]={
/* TODO: these two work on faces and brushes, shouldn't be here. Should
probably make a parameter passing system so lists can be passed to commands.
If a function is marked as accepting a list of faces, it can be given
a list of the selected faces, or a list of all selected faces on all
selected brushes.
*/
{"face_edit",C_face_edit,"Edit texture alignment information for selected faces/brushes."},
{"face_flags",C_face_flags,"Edit face flags for selected faces/brushes."},
};

static void RegCmds(void) __attribute__ ((constructor));
static void RegCmds(void)
{
   Cmd_Register(face_cmds,sizeof(face_cmds));
}

