#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "3d.h"
#include "clickbr.h"
#include "error.h"
#include "keyhit.h"
#include "memory.h"
#include "mouse.h"
#include "quest.h"
#include "status.h"


static void C_get_distance(void)
{
   viewport_t *vp;
   
   vec3_t *opts,*otpts;
   int onpts;
   int odraw;

   vec3_t v,ov;
   

   vp=&M.display.vport[M.display.active_vport];
   if (vp->mode!=NOPERSP)
   {
      HandleError("get_distance","Must be in a 2d viewport!");
      return;
   }

   opts=M.pts;
   otpts=M.tpts;
   onpts=M.npts;
   odraw=status.draw_pts;

   M.pts=Q_malloc(sizeof(vec3_t)*2);
   M.tpts=Q_malloc(sizeof(vec3_t)*2);
   if (!M.pts || !M.tpts)
   {
      Q_free(M.pts);
      Q_free(M.tpts);
      
      M.pts=opts;
      M.tpts=otpts;
      M.npts=onpts;
      status.draw_pts=odraw;
   }
   M.npts=2;

   GetRealPos(mouse.x,mouse.y,&v);
   M.pts[1]=M.pts[0]=v;

   ov=v;

   status.draw_pts=3;
   
   UpdateViewport(M.display.active_vport,1);
      
   do
   {
      CheckMoveKeys();
		UpdateMouse();

      if (!InBox(vp->xmin,vp->ymin,vp->xmax,vp->ymax))
      {
         UndrawMouse(mouse.x,mouse.y);
         if (mouse.x >= vp->xmax)
         {
            mouse.x = vp->xmax - 1;
            SetMousePos(mouse.x, mouse.y);
         }
         if (mouse.x <= vp->xmin)
         {
            mouse.x = vp->xmin + 1;
            SetMousePos(mouse.x, mouse.y);
         }
         if (mouse.y >= vp->ymax)
         {
            mouse.y = vp->ymax - 1;
            SetMousePos(mouse.x, mouse.y);
         }
         if (mouse.y <= vp->ymin)
         {
            mouse.y = vp->ymin + 1;
            SetMousePos(mouse.x, mouse.y);
         }
         DrawMouse(mouse.x,mouse.y);
      }

		GetRealPos(mouse.x,mouse.y,&v);

      if ((v.x!=ov.x) || (v.y!=ov.y) || (v.z!=ov.z))
      {
         M.pts[M.npts-1]=v;
         ov=v;
         UpdateViewport(M.display.active_vport,1);
         DrawMouse(mouse.x,mouse.y);
      }

      if (mouse.button)
         break;
   } while (1);
   
   Q_free(M.pts);
   Q_free(M.tpts);
   
   M.pts=opts;
   M.tpts=otpts;
   M.npts=onpts;
   status.draw_pts=odraw;
   
   UpdateAllViewports();
}

static cmd_reg_t cmds[]={
{"get_distance",C_get_distance,"Lets you check the distance between two points (in a 2d viewport)."},
};

static void RegCmds(void) __attribute__ ((constructor));
static void RegCmds(void)
{
   Cmd_Register(cmds,sizeof(cmds));
}

