#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "quest.h"
#include "texdef.h"


static void C_m_left (void) { Texdef_MoveSel(&M.sel,MOVE_LEFT ); Cmd_SetRedraw(2); }
static void C_m_right(void) { Texdef_MoveSel(&M.sel,MOVE_RIGHT); Cmd_SetRedraw(2); }
static void C_m_up   (void) { Texdef_MoveSel(&M.sel,MOVE_UP   ); Cmd_SetRedraw(2); }
static void C_m_down (void) { Texdef_MoveSel(&M.sel,MOVE_DOWN ); Cmd_SetRedraw(2); }

static void C_s_dx(void) { Texdef_ScaleSel(&M.sel,MOVE_LEFT ); Cmd_SetRedraw(2); }
static void C_s_ix(void) { Texdef_ScaleSel(&M.sel,MOVE_RIGHT); Cmd_SetRedraw(2); }
static void C_s_dy(void) { Texdef_ScaleSel(&M.sel,MOVE_UP   ); Cmd_SetRedraw(2); }
static void C_s_iy(void) { Texdef_ScaleSel(&M.sel,MOVE_DOWN ); Cmd_SetRedraw(2); }

static cmd_reg_t cmds[]={
{"texture.move.left" ,C_m_left ,{NULL,"control+left" },{0,"texture.move"},"Move selected texdefs left." },
{"texture.move.right",C_m_right,{NULL,"control+right"},{0,"texture.move"},"Move selected texdefs right."},
{"texture.move.up"   ,C_m_up   ,{NULL,"control+up"   },{0,"texture.move"},"Move selected texdefs up."   },
{"texture.move.down" ,C_m_down ,{NULL,"control+down" },{0,"texture.move"},"Move selected texdefs down." },

{"texture.scale.dec_x",C_s_dx,{NULL,"control+shift+left" },{0,"texture.scale"},"Decrease x scale of selected texdefs."},
{"texture.scale.inc_x",C_s_ix,{NULL,"control+shift+right"},{0,"texture.scale"},"Increase x scale of selected texdefs."},
{"texture.scale.dec_y",C_s_dy,{NULL,"control+shift+up"   },{0,"texture.scale"},"Decrease y scale of selected texdefs."},
{"texture.scale.inc_y",C_s_iy,{NULL,"control+shift+down" },{0,"texture.scale"},"Increase y scale of selected texdefs."},
};

#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/texmove","Commands to move and scale textures on faces."}};

PLUGIN_FOOT_CMDS

