#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "config.h"
#include "quest.h"
#include "s_message.h"
#include "s_texpick.h"
#include "status.h"
#include "texdef.h"


static void C_pick(void)
{
   char buf[MAX_TEXTURE_NAME];
   
   if (!S_TexturePicker(buf,cv_texture_current->s))
      return;

   Cfg_SetStr(cv_texture_current,buf);

   if (M.sel.bsel || M.sel.fsel)
   {
      SetTextureSel(&M.sel,buf);
      Cmd_SetRedraw(2);
      S_NewMessage("Applied texture '%s' to selection.",buf);
   }
   else
   {
      S_NewMessage("Current texture set to '%s'.",buf);
   }
}


static void C_apply(void)
{
   if (M.sel.bsel || M.sel.fsel)
   {
      SetTextureSel(&M.sel,cv_texture_current->s);
      Cmd_SetRedraw(2);
      S_NewMessage("Applied texture '%s' to selection.",cv_texture_current->s);
   }
   else
      S_NewMessage("texture.apply: Nothing selected!");
}


static cmd_reg_t cmds[]={
{"texture.pick" ,C_pick ,{"Texture/Pick...","control+t"},{},"Brings up the texture picker and assigns the texture to the selection.",NULL},
{"texture.apply",C_apply,{"Texture/Apply","alt+t"      },{},"Applies the current texture to the selection.",NULL},
};

#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/texset","Commands to texture objects."}};

PLUGIN_FOOT_CMDS

