/*
defines.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef DEFINES_H
#define DEFINES_H

#ifndef TRUE
#define TRUE  1
#endif
#ifndef FALSE
#define FALSE 0
#endif


#ifndef MAX_PATH
#define MAX_PATH 256
#endif

#define MAX_TEXTURE_NAME 128
/* If we can't find a real texture name */
#define DEFAULT_TEXTURE "no_texture"


#define  MOVE_UP        1
#define  MOVE_DOWN      2
#define  MOVE_LEFT      3
#define  MOVE_RIGHT     4
#define  MOVE_FORWARD   5
#define  MOVE_BACKWARD  6


#ifdef _UNIX

#ifndef PI
#define PI 3.14159265358979323846
#endif

#define stricmp(a, b) strcasecmp((a), (b))
#define strnicmp(a, b, c) strncasecmp((a), (b), (c))

char *strlwr(char *string);

#endif  /* _UNIX */


#ifdef _MINGW32
char *strlwr(char *string);
double rint(double d);
#endif


/* TODO: while debugging */
#include "qassert.h"
#define ARG_UNUSED(x) x __attribute__ ((unused))


#define ALPHA
#define BETA


#endif

