#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "edsel.h"

#include "memory.h"
#include "quest.h"
#include "s_render.h"
#include "sel.h"


vsel_t *FindSelVert(struct brush_s *b,int num)
{
   return Sel_FindVert(&M.sel,b,num);
}
fsel_t *FindSelFace(struct brush_s *b,int num)
{
   return Sel_FindFace(&M.sel,b,num);
}
bsel_t *FindSelBrush(struct brush_s *b)
{
   return Sel_FindBrush(&M.sel,b);
}
esel_t *FindSelEnt(entity_t *e)
{
   return Sel_FindEnt(&M.sel,e);
}

void AddSelVert(struct brush_s *b,int num)
{
   Sel_AddVert(&M.sel,b,num);
}
void AddSelFace(struct brush_s *b,int num)
{
   Sel_AddFace(&M.sel,b,num);
}
void AddSelBrush(struct brush_s *b)
{
   Sel_AddBrush(&M.sel,b);
}
void AddSelEnt(entity_t *e)
{
   Sel_AddEnt(&M.sel,e);
}

void RemoveSelVert(vsel_t *vs)
{
   Sel_RemoveVert(&M.sel,vs);
}
void RemoveSelFace(fsel_t *fs)
{
   Sel_RemoveFace(&M.sel,fs);
}
void RemoveSelBrush(bsel_t *bs)
{
   Sel_RemoveBrush(&M.sel,bs);
}
void RemoveSelEnt(esel_t *es)
{
   Sel_RemoveEnt(&M.sel,es);
}

void ClearSelVerts(void)
{
	vsel_t *v;

	M.sel.num_vselected = 0;
	for (v=M.sel.vsel; v; v=M.sel.vsel)
	{
		M.sel.vsel=v->Next;
		Q_free(v);
	}
	M.sel.vsel=NULL;
   S_R_SelUpdate();
}

void ClearSelFaces(void)
{
	fsel_t *f;

   ClearSelVerts();
	M.sel.num_fselected = 0;
	for (f=M.sel.fsel; f; f=M.sel.fsel)
	{
		M.sel.fsel=f->Next;
		Q_free(f);
	}
	M.sel.fsel=NULL;
   S_R_SelUpdate();
}

void ClearSelBrushes(void)
{
	bsel_t *b;

	ClearSelVerts();
   ClearSelFaces();
	M.sel.num_bselected = 0;
	for (b=M.sel.bsel; b; b=M.sel.bsel)
	{
		M.sel.bsel=b->Next;
		Q_free(b);
	}
	M.sel.bsel=NULL;
   S_R_SelUpdate();
}

void ClearSelEnts(void)
{
	esel_t *e;
	
	M.sel.num_eselected = 0;
	for (e=M.sel.esel;e;e=M.sel.esel)
	{
		M.sel.esel=e->Next;
		Q_free(e);
	}
	M.sel.esel=NULL;
   S_R_SelUpdate();
}


void ClearSelAll(void)
{
   ClearSelVerts();
   ClearSelFaces();
   ClearSelBrushes();
   ClearSelEnts();
}

