/*
entclass.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef ENTCLASS_H
#define ENTCLASS_H


typedef struct
{
   char *name;
   char *val;
} e_key_choice_t;


typedef struct
{
   char *name;
   int type;

   union
   {
      struct
      {
         e_key_choice_t *choices;
         int num_choices;
      } ch;
      struct
      {
         char *name;
      } list;
   } x;
} e_key_t;

#define EKEY_CHOICE   0
#define EKEY_LIST     1
#define EKEY_TEXTURE  2

#define EKEY_Q2_COLOR 3

#define EKEY_HL_COLOR 4
#define EKEY_HL_LIGHT 5


typedef struct
{
   char *key,*value;
} e_default_t;


typedef struct eclass_s
{
   char *name;
   int type;

   float color[3];
   vec3_t min,max;

   char **flags;
   int num_flags;

   char *comment;

   e_key_t *keys;
   int num_keys;

   e_default_t *defs;
   int num_defs;

   /* TODO */
/*   struct mdl_s *mdl;*/
} eclass_t;

#define ECLASS_MODEL 1
#define ECLASS_POINT 2
#define ECLASS_BASE  4


extern eclass_t **eclasses;
extern int num_eclasses;

extern eclass_t eclass_dummy;

int InitEClass(const char *path);
void DoneEClass(void);

eclass_t *FindClass(const char *classname);

void SetEntityDefaults(entity_t *e);

#endif

