#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "gtk/glade_support.h"

#undef FALSE
#undef TRUE

#include "defines.h"
#include "types.h"

#include "s_gui.h"

#include "entclass.h"


#define TREE_DATA_FIELD "quest-ep-data"


static GtkWidget *ep;
static GtkEntry *entry;
static int done;


gboolean
ep_delete                              (ARG_UNUSED(GtkWidget       *widget),
                                        ARG_UNUSED(GdkEvent        *event),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=0;
   gtk_main_quit();
   return TRUE;
}


void
ep_entry_activate                      (ARG_UNUSED(GtkEditable     *editable),
                                        ARG_UNUSED(gpointer         user_data))
{
   gtk_container_focus(GTK_CONTAINER(ep),GTK_DIR_TAB_FORWARD);
}


void
ep_ok_clicked                          (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=1;
   gtk_main_quit();
}


void
ep_cancel_clicked                      (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=0;
   gtk_main_quit();
}


void
ep_tree_select                         (GtkTree         *tree,
                                        ARG_UNUSED(gpointer         user_data))
{
   const char *c;
   GList *sel;
   
   sel=GTK_TREE_SELECTION(tree);
   if (sel && sel->data)
   {
      c=gtk_object_get_data(GTK_OBJECT(sel->data),TREE_DATA_FIELD);
      if (c)
         gtk_entry_set_text(entry,c);
   }
}


int S_GUI_EntityPicker(char *dst,int type)
{
   int i;
   eclass_t **e;
   char last[128];
   
   GtkTree *t;
   GtkWidget *ti;
   GtkTree *lt;

   ep=create_ep();
   entry=GTK_ENTRY(lookup_widget(ep,"entry"));

   t=GTK_TREE(lookup_widget(ep,"tree"));
   lt=NULL;
   
   last[0]=0;
   for (i=0,e=eclasses;i<num_eclasses;i++,e++)
   {
      if (!((*e)->type&type))
         continue;

      if (last[0] && !strncmp((*e)->name,last,strlen(last)))
      {
         ti=gtk_tree_item_new_with_label(&(*e)->name[strlen(last)]);
         gtk_object_set_data(GTK_OBJECT(ti),TREE_DATA_FIELD,(*e)->name);
         gtk_tree_append(lt,ti);
         gtk_widget_show(ti);
      }
      else
      if (strchr((*e)->name,'_'))
      {
         strcpy(last,(*e)->name);
         *strchr(last,'_')=0;

         ti=gtk_tree_item_new_with_label(last);
         gtk_tree_append(t,ti);
         gtk_widget_show(ti);

         lt=GTK_TREE(gtk_tree_new());
         gtk_tree_item_set_subtree(GTK_TREE_ITEM(ti),GTK_WIDGET(lt));

         strcat(last,"_");

         ti=gtk_tree_item_new_with_label(&(*e)->name[strlen(last)]);
         gtk_object_set_data(GTK_OBJECT(ti),TREE_DATA_FIELD,(*e)->name);
         gtk_tree_append(lt,ti);
         gtk_widget_show(ti);
      }
      else
      {
         ti=gtk_tree_item_new_with_label((*e)->name);
         gtk_object_set_data(GTK_OBJECT(ti),TREE_DATA_FIELD,(*e)->name);
         gtk_tree_append(t,ti);
         gtk_widget_show(ti);
      }
   }

   gtk_widget_show(ep);
   gtk_main();

   if (done==1)
      strcpy(dst,gtk_entry_get_text(entry));
   
   gtk_widget_destroy(ep);
   ep=NULL;

   return done;
}

