#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "qassert.h"

#include "s_error.h"
#include "s_popup.h"


static GtkMenu *menu;
static int sel;
static int num;


static void pop_click(GtkWidget *w,int data)
{
   sel=data;
   gtk_main_quit();
}


void S_Popup_Init(void)
{
   QASSERT(!menu);
   menu=GTK_MENU(gtk_menu_new());
   gtk_signal_connect(GTK_OBJECT(menu),"deactivate",GTK_SIGNAL_FUNC(pop_click),-1);
   num=0;
}

void S_Popup_AddStr(const char *format, ...)
{
   char buf[256];
   va_list args;
   GtkMenuItem *mi;
   
   va_start(args,format);
   vsnprintf(buf,sizeof(buf),format,args);
   va_end(args);

   mi=GTK_MENU_ITEM(gtk_menu_item_new_with_label(buf));
   gtk_menu_append(menu,GTK_WIDGET(mi));
   gtk_signal_connect(GTK_OBJECT(mi),"activate",GTK_SIGNAL_FUNC(pop_click),num);
   num++;
   gtk_widget_show(GTK_WIDGET(mi));
}

int S_Popup_Display(void)
{
   sel=-1;
   gtk_menu_popup(menu,NULL,NULL,NULL,NULL,0,0);
   gtk_main();
   return sel;
}

void S_Popup_Free(void)
{
   gtk_widget_destroy(GTK_WIDGET(menu));
   menu=NULL;
}

