#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>

#include "defines.h"
#include "types.h"

#include "trace.h"

#include "brush.h"
#include "geom.h"
#include "quest.h"



void Trace(vec3_t org,vec3_t dir,scalar_t len,int flags,
   void (*func)(scalar_t dist,int type,void *v,int face))
{
   vec3_t s,e;
   vec3_t d;
   vec3_t a;

   brush_t *b;
   int i,j;

   scalar_t f,g,h;

   s=org;
   d=dir;

   e.x=s.x+d.x*len;
   e.y=s.y+d.y*len;
   e.z=s.z+d.z*len;

/* We trace from s to e, direction is d */

   if (flags&TRACE_FACE)
   {
      for (b=M.VBrushHead;b;b=b->VNext)
      {
/* TODO: handle curves and entities */
         if (b->bt->type==BRUSH_NORMAL)
         {
            for (i=0;i<b->num_faces;i++)
            {
               f=DotProd(s,b->faces[i].normal)-b->faces[i].dist;
               g=DotProd(e,b->faces[i].normal)-b->faces[i].dist;
   
               if ((f<0 && g<0) || (f>0 && g>0))
                  continue;
   
               g=DotProd(d,b->faces[i].normal);
               if (fabs(g)<0.0001)
                  continue;
   
               h=-f/g;
   
               a.x=s.x+d.x*h;
               a.y=s.y+d.y*h;
               a.z=s.z+d.z*h;
   
               /* now make sure a is actually in the face by checking it
                against the planes of the other faces in the brush */
               for (j=0;j<b->num_faces;j++)
               {
                  if (i==j)
                     continue;
   
                  f=DotProd(a,b->faces[j].normal)-b->faces[j].dist;
                  if (f>0) break;
               }
   
               if (j!=b->num_faces)
                  continue;
   
               func(h,TRACE_FACE,b,i);
            }
         }
      }
   }
}

