/*
types of variables:

	internal, never seen by user (menu_file)
	should be remembered (if not default), never seen by user (configurations)
	set by user, should be remembered (path to wad, e.g. separate for Quake I and Hexen)


Interfaces with Quest v3.0:

	quest-classic: like Quest v2.*
	quest-default: start with Quest v2.*, enhanced, updated with new stuff
	quest-hardcore: (better name?) really powerful, optimized for effective editing for people who know what they're doing
	               and have the time to learn the interface properly

	maybe radient: (qe|gtk)radient-clone?

*/

(config game.quake
	(
		(description "Quake I support")
		(provides game)
	)

	(default game.sys.quake1.pal "game/quake1/quake.pal")
	(default game.sys.quake1.default_wad "quake.wad")
	(default texture.current "quake_todo")
	
	(plugin.load game.sys.quake1)
	
	(menu.set menu_game)
	(bind game.sys.quake1.select_wad (menu "_Select .wad"))
	(menu.set nil)
	
	(entity_set.load "game/quake1/quake.es")
	(texcat.load "game/quake1/quake.tc")
)

(config game.hexen
	(
		(description "Hexen support")
		(provides game)
	)

	(default game.sys.quake1.pal "game/hexen/hexen.pal")
	(default game.sys.quake1.wad_path "hexen.wad")
	(default texture.current "hexen_todo")

	(plugin.load game.sys.quake1)

	(entity_set.load "game/hexen2/hexen2.es")
)


/*
(config checker.curves
	(
		(description "Checks for errors in bezier patch arrays")
		(requires checker)
	)
	(plugin.load checker.curves)
	(checker.add checker.curves)
)

(config checker.quake3
	(
		(description "Checks for Quake 3-specific errors")
		(requires game.quake3 checker)
	)
	(plugin.load checker.quake3)
	(checker.add checker.quake3)
)

(defun game.quake3.load_checkers () ()
	(if (config.have checker)
		(
			(config.load checker.curves)
			(config.load checker.quake3)
		)
	)
)

(config game.quake3
	(
		(description "Configuration for Quake 3")
		(provides game)
		(recommends checker)
	)

	(plugin.load game.quake3)

	(entity.load_entity_set "game/quake3/quake3.es")
	(texture.load_categories "game/quake3/quake3.cat")
	(game.quake3.load_checkers)
)

(config game.ra3
	(
		(description "Configuration for the Quake 3 mod Rocket Arena 3")
		(provides game)
		(recommends checker)
	)
	(plugin.load game.quake3)
	(entity.load_entity_set "game/quake3/ra3.es")
	(texture.load_categories "game/quake3/quake3.cat")
	(game.quake3.load_checkers)
)

*/

(config ui.quest-classic
	(
		(description "Classic Quest UI (v1.*, v2.*)")
		(provides ui)
	)

	(plugin.load basic camera brush.create edit.misc edit.select edit.move
		edit.clipboard render.flags.cmds edit.trans edit.texture.set
		entity.basic csg.intersect csg.join csg.rmhl csg.subtract
		csg.weld texture.move edit.snap)

	(set menu_file (menu.add nil "_File"))
	(set menu_edit (menu.add nil "_Edit"))
	(set menu_brush (menu.add nil "_Brush"))
	(set menu_csg (menu.add menu_brush "_CSG"))
	(set menu_face (menu.add nil "_Face"))
	(set menu_entity (menu.add nil "E_ntity"))
	(set menu_group (menu.add nil "_Group"))
	(set menu_camera (menu.add nil "_Camera"))
	(set menu_view (menu.add nil "_View"))
	(set menu_game (menu.add nil "_Game"))
	(set menu_misc (menu.add nil "_Misc"))
	(set menu_plugins (menu.add nil "_Plugins"))
	(set menu_help (menu.add nil "_Help"))

	(menu.set menu_file)
	(bind basic.map_new (menu "_New"))
	(bind basic.map_load (menu "_Load..."))
	(bind basic.map_save "control+s" (menu "_Save"))
	(bind basic.map_save_as (menu "S_ave as..."))
	(menu nil) /* add a seperator */
	(bind basic.exit "escape" (menu "E_xit"))
	(menu.set nil)

	(menu.set (menu.add menu_brush "C_reate"))
	(bind brush.create.cube (menu "_Cube") "alt+c")
	(bind brush.create.prism (menu "_Prism"))
	(bind brush.create.room (menu "_Room"))
	(bind brush.create.pyramid (menu "_Pyramid"))
	(bind brush.create.dodec (menu "_Dodecahedron"))
	(bind brush.create.icos (menu "_Icosahedron"))
	(bind brush.create.bucky (menu "_Buckyball"))
	(bind brush.create.torus (menu "_Torus"))
	(menu.set nil)
	
	(menu.set menu_entity)
	(bind entity.create "alt+e" (menu "_Create"))
	(bind entity.create_model "control+alt+e" (menu "Create _model"))
	(bind entity.edit "control+e" (menu "_Edit"))
	(bind entity.add_brush "alt+a" (menu "_Add brush"))
	(menu.set nil)

	(menu.set menu_csg)
	(bind csg.subtract "i" (menu "_Subtract"))
	(bind csg.intersect "o" (menu "_Intersect"))
	(bind csg.room "r" (menu "_Room"))
	(bind csg.hollow "h" (menu "_Hollow"))
	(bind csg.join "j" (menu "_Join"))
	(bind csg.weld "w" (menu "_Weld"))
	(menu.set nil)

/*
 @@"Modify..."

  @@@"Rotate"=brush_rotate

  @@@"Scale"=brush_scale

  @@@"Snap brush"=brush_snap

  @@@"Snap vertices"=brush_snap_verts

 @@"Delete"=brush_delete

 @@"CSG..."

  @@@"Subtract"=csg_subtract

  @@@"Intersect"=csg_intersect

  @@@"Make hollow"=csg_hollow

  @@@"Make room"=csg_room

 @@"Join"=csg_join

 @@"Weld"=csg_weld



@"Curve..."

 @@"Create"=curve_create



@"Entity..."

 @@"Create"=entity_create

 @@"Edit"=entity_edit

 @@"Rotate"=entity_rotate

 @@"Delete"=entity_delete



@"Model..."

 @@"Create"=model_create

 @@"Add to"=model_add

 @@"Edit"=entity_edit

 @@"Delete"=entity_delete

 @@"List"=model_list





@"Misc..."

 @@"Create Link"=model_link

 @@"Check Map"=check_map

 @@"Map Information"=mapinfo

 @@"Build Level"=build_map

 @@"Find leak"=find_leak

 @@"Group"=group_popup

 @@"Screen Capture"=screenshot



@"Textures..."

 @@"Select texture"=texture_pick

 @@"Select .wad file"=texture_select_wad

 @@"Reread cache"=texture_cache_reread

 @@"Fix duplicates"=texture_fix_duplicates



@"Settings..."

 @@"ReInit Camera"=camera_reinit

 @@"Preferences"=set_prefs



@"Undo Last"=undo
*/

	(bind (lambda () (camera.move DIR_LEFT)) "left")
	(bind (lambda () (camera.move DIR_RIGHT)) "right")
	(bind (lambda () (camera.move DIR_UP)) "up")
	(bind (lambda () (camera.move DIR_DOWN)) "down")
	(bind (lambda () (camera.move DIR_FORWARD)) "a")
	(bind (lambda () (camera.move DIR_BACKWARD)) "z")

	(bind (lambda () (camera.rotate DIR_LEFT)) "alt+left")
	(bind (lambda () (camera.rotate DIR_RIGHT)) "alt+right")
	(bind (lambda () (camera.rotate DIR_UP)) "alt+up")
	(bind (lambda () (camera.rotate DIR_DOWN)) "alt+down")
/* TODO: move these to different keys?
	(bind (lambda () (camera.rotate DIR_FORWARD)) "c")
	(bind (lambda () (camera.rotate DIR_BACKWARD)) "d")
*/
	(bind camera.move_drag "mouse-right")

	(menu.set menu_camera)
	(bind camera.zoom_in "s" "mouse-wheel-up")
	(bind camera.zoom_out "x" "mouse-wheel-down")
	(bind camera.zoom_to "f2" (menu "Zoom _to"))
	(bind camera.reset "control+alt+c" (menu "_Reset"))
	(menu.set nil)

	(menu.set menu_edit)

	(bind edit.select.all "control+a")
	(bind edit.select.control "control+mouse-left")
	(bind edit.select.shift "shift+mouse-left")
	(bind edit.select.face_next "control+plus")
	(bind edit.select.face_prev "control+minus")

	(bind undo "control+z" (menu "_Undo"))
	(menu nil)
	(bind edit.copy "control+c" (menu "_Copy"))
	(bind edit.paste "control+v" (menu "_Paste"))
	(bind edit.delete "delete" (menu "_Delete"))
	(menu nil)
	(bind edit.select.clear "q" (menu "_Clear selection"))

	(bind edit.toggle_texlock (menu "Toggle texture-_locking"))
	(bind edit.grid_inc "plus" (menu "_Inc grid size"))
	(bind edit.grid_dec "minus" (menu "_Dec grid size"))

	(bind (lambda () (edit.move DIR_UP)) "shift+up")
	(bind (lambda () (edit.move DIR_DOWN)) "shift+down")
	(bind (lambda () (edit.move DIR_LEFT)) "shift+left")
	(bind (lambda () (edit.move DIR_RIGHT)) "shift+right")
	(bind (lambda () (edit.move DIR_FORWARD)) "shift+page-up")
	(bind (lambda () (edit.move DIR_BACKWARD)) "shift+page-down")

	(bind edit.move_drag "mouse-left")
	
	(bind (lambda () (texture.move DIR_LEFT)) "control+left")
	(bind (lambda () (texture.move DIR_RIGHT)) "control+right")
	(bind (lambda () (texture.move DIR_UP)) "control+up")
	(bind (lambda () (texture.move DIR_DOWN)) "control+down")
	(bind (lambda () (texture.scale DIR_LEFT)) "control+shift+left")
	(bind (lambda () (texture.scale DIR_RIGHT)) "control+shift+right")
	(bind (lambda () (texture.scale DIR_UP)) "control+shift+up")
	(bind (lambda () (texture.scale DIR_DOWN)) "control+shift+down")
	
	(bind edit.snap "control+n" (menu "_Snap to grid"))

	(menu nil)

	(bind edit.trans.scale "control+g" (menu "_Scale"))
	(bind edit.trans.rotate "control+r" (menu "_Rotate"))
	(bind edit.trans.mirror "control+m" (menu "_Mirror"))

	(menu nil)

	(bind edit.texture.pick "control+t" (menu "_Pick texture"))
	(bind edit.texture.apply "alt+t")

	(menu.set nil)

	(menu.set menu_view)
	(bind render.flags.change "control+alt+r" (menu "_Display"))
	(menu.set nil)

/* for testing error handling */
	(bind (lambda () (undo.stats)) "control+alt+t")
	
	(plugin.load cfg.manager)
	(menu.set menu_file)
	(menu nil)
	(bind cfg.manager (menu "_Config..."))
	(menu.set nil)
)

(config Quest
	(
		(description "(internal) Main configuration")
	)

	/* TODO: these should be defined in Quest (ql.c?) and not here */
	(set DIR_UP 1)
	(set DIR_DOWN 2)
	(set DIR_LEFT 3)
	(set DIR_RIGHT 4)
	(set DIR_FORWARD 5)
	(set DIR_BACKWARD 6)

	(define configurations (ui.quest-classic) "List of default configurations to load on startup.")
	(config.load configurations) /* TODO */
)


(config gtk_gl.settings
	((description "(internal) GTK+/OpenGL frontend"))
)

(config gtk_gl.ui
	(
		(description "(internal) GTK+/OpenGL frontend UI")
	)
	
	(menu.set menu_view)
	(bind gtk_gl.new_viewport (menu "_New viewport"))
	(menu nil)
	(bind gl.toggle_3d "f" (menu "2_d/3d"))
	(bind gl.toggle_grid "g" (menu "Toggle _grid"))
	(menu nil)
	(bind gl.toggle_texture "t" (menu "_Textured"))
	(bind gl.toggle_flat "alt+h" (menu "_Flat"))
	(menu.set nil)
)
