#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gtkgl/gtkglarea.h>

#undef TRUE
#undef FALSE

#include "quest/defines.h"
#include "quest/types.h"

#include "quest/fe/int.h"

#include "g_3d_all.h"
#include "../input.h"

#include "quest/fe/input.h"
#include "quest/fe/message.h"

#include "quest/error.h"


/* TODO: think of some better way to do this */
#define ARG_UNUSED(x) x __attribute__ ((unused))


static int selection_window_event(ARG_UNUSED(GtkWidget *w),ARG_UNUSED(GdkEventButton *e),ARG_UNUSED(gpointer data))
{
   gtk_main_quit();
   return 1;
}


static int cur_sx,cur_sy,cur_ex,cur_ey;

void S_SelectionWindow_DrawBox(int x0,int y0,int x1,int y1);

static int selection_window_mevent(ARG_UNUSED(GtkWidget *w),GdkEventMotion *e,ARG_UNUSED(gpointer data))
{
   int x,y;
   GdkModifierType s;
   
   if (e->is_hint)
   {
      gdk_window_get_pointer(e->window,&x,&y,&s);
   }
   else
   {
      x=e->x;
      y=e->y;
   }

   if (x!=cur_ex || y!=cur_ey)
   {
      cur_ex=x;
      cur_ey=y;
      
      if (!gtk_gl_area_make_current(S_cur_gvport->gla))
         return 1;
      S_GL_SelectionWindow_DrawBox(cur_sx,cur_sy,cur_ex,cur_ey);
      gtk_gl_area_swap_buffers(S_cur_gvport->gla);
   }

   return 1;
}

int S_I_SelectionWindow(vec3_t *min,vec3_t *max)
{
   int x,y;

   S_process_key=S_process_mouse=0;

   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_press_event",GTK_SIGNAL_FUNC(selection_window_event),NULL);
   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_release_event",GTK_SIGNAL_FUNC(selection_window_event),NULL);
   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"motion_notify_event",GTK_SIGNAL_FUNC(selection_window_mevent),NULL);
   
   gdk_pointer_grab(GTK_WIDGET(S_cur_gvport->win)->window,TRUE,
      GDK_BUTTON_RELEASE_MASK|GDK_BUTTON_PRESS_MASK|
      GDK_POINTER_MOTION_MASK|GDK_POINTER_MOTION_HINT_MASK,
      GTK_WIDGET(S_cur_gvport->win)->window,NULL,0);

   gdk_window_get_pointer(GTK_WIDGET(S_cur_gvport->win)->window,&x,&y,NULL);
   min->x=  x/(double)S_GL_vport->sx*2-1;
   min->y=-(y/(double)S_GL_vport->sy*2-1);
   min->z=0;

   cur_sx=cur_ex=x;
   cur_sy=cur_ey=y;
   gtk_main();

   gdk_window_get_pointer(GTK_WIDGET(S_cur_gvport->win)->window,&x,&y,NULL);
   max->x=  x/(double)S_GL_vport->sx*2-1;
   max->y=-(y/(double)S_GL_vport->sy*2-1);
   max->z=0;
   
   gdk_pointer_ungrab(0);
   
   gtk_signal_disconnect_by_func(GTK_OBJECT(S_cur_gvport->win),GTK_SIGNAL_FUNC(selection_window_mevent),NULL);
   gtk_signal_disconnect_by_func(GTK_OBJECT(S_cur_gvport->win),GTK_SIGNAL_FUNC(selection_window_event),NULL);

   S_process_key=S_process_mouse=1;

   if (min->x>max->x)
   {
      double t;
      t=min->x;
      min->x=max->x;
      max->x=t;
   }
   if (min->y>max->y)
   {
      double t;
      t=min->y;
      min->y=max->y;
      max->y=t;
   }

   return 1;
}


static int oldx,oldy;
static int flags;
static s_event_t *se;

static int si_event(ARG_UNUSED(GtkWidget *w),GdkEvent *event,ARG_UNUSED(gpointer data))
{
   GdkModifierType s;
   int x,y;
   
   switch (event->type)
   {
   case GDK_MOTION_NOTIFY:
      {
         GdkEventMotion *e=(GdkEventMotion *)event;

         gdk_window_get_pointer(e->window,&x,&y,&s);
         
         se->dx=x-oldx;
         se->dy=y-oldy;
         oldx=x;
         oldy=y;
         se->mp.x=  x/(double)S_GL_vport->sx*2-1;
         se->mp.y=-(y/(double)S_GL_vport->sy*2-1);
         se->key=S_Input_ConvState(s);
         se->type=S_I_MOTION;
         gtk_main_quit();
      }
      break;

   case GDK_BUTTON_PRESS:
      {
         GdkEventButton *e=(GdkEventButton *)event;

         gdk_window_get_pointer(e->window,&x,&y,&s);
         se->mp.x=  x/(double)S_GL_vport->sx*2-1;
         se->mp.y=-(y/(double)S_GL_vport->sy*2-1);
         
         se->dx=se->dy=0;
         se->key=S_Input_ConvState(e->state);
         switch (e->button)
         {
         case 1: se->key|=KEY_BUTTON1; break;
         case 3: se->key|=KEY_BUTTON2; break;
         case 2: se->key|=KEY_BUTTON3; break;
         default: break;
         }
         se->type=S_I_CLICK;
         gtk_main_quit();
      }
      break;
      
   case GDK_BUTTON_RELEASE:
      {
         GdkEventButton *e=(GdkEventButton *)event;

         gdk_window_get_pointer(e->window,&x,&y,&s);
         se->mp.x=  x/(double)S_GL_vport->sx*2-1;
         se->mp.y=-(y/(double)S_GL_vport->sy*2-1);
         
         se->dx=se->dy=0;
         se->key=S_Input_ConvState(e->state);
         switch (e->button)
         {
         case 1: se->key|=KEY_BUTTON1; break;
         case 3: se->key|=KEY_BUTTON2; break;
         case 2: se->key|=KEY_BUTTON3; break;
         default: break;
         }
         se->type=S_I_RELEASE;
         gtk_main_quit();
      }
      break;
      
   default:
      break;
   }
   return 1;
}

void S_I_Setup(s_event_t *e,int pflags,const char *msg)
{
   memset(e,0,sizeof(s_event_t));
   flags=pflags;

	if (msg)
		S_NewMessage("%s",msg);
   
   S_process_key=S_process_mouse=0;

   if (flags&(S_I_CLICK|S_I_RELEASE))
   {
      gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_press_event",GTK_SIGNAL_FUNC(si_event),NULL);
      gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_release_event",GTK_SIGNAL_FUNC(si_event),NULL);
   }
   if (flags&S_I_MOTION)
      gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"motion_notify_event",GTK_SIGNAL_FUNC(si_event),NULL);
   if (flags&S_I_KEY)
      ASSERT(1); /* TODO */
   
   gdk_pointer_grab(GTK_WIDGET(S_cur_gvport->win)->window,TRUE,
      GDK_BUTTON_RELEASE_MASK|GDK_BUTTON_PRESS_MASK|
      GDK_POINTER_MOTION_MASK|GDK_POINTER_MOTION_HINT_MASK,
      GTK_WIDGET(S_cur_gvport->win)->window,NULL,0);
      
   gdk_window_get_pointer(GTK_WIDGET(S_cur_gvport->win)->window,&oldx,&oldy,NULL);
}

void S_I_Done(void)
{
   gdk_pointer_ungrab(0);
   
   gtk_signal_disconnect_by_func(GTK_OBJECT(S_cur_gvport->win),GTK_SIGNAL_FUNC(si_event),NULL);

   S_process_key=S_process_mouse=1;
}

void S_I_Wait(s_event_t *e)
{
   se=e;
   gtk_main();
}

