#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fe/input.h"


static const char
   *keym_shift  ="shift",
   *keym_alt    ="alt",
   *keym_control="control";

static const char *keys[256]={
/* 0x00-0x0f */
0,"escape","enter","space","tab","backspace","colon","quote",
"tilde","pipe","comma","period",
"question-mark","center","left-bracket","right-bracket",

/* 0x10-0x1f */
"up","down","left","right","insert","delete","home","end",
"page-up","page-down","minus","plus",0,0,0,0,

/* 0x20-0x2f */
"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p",
/* 0x30-0x3f */
"q","r","s","t","u","v","w","x","y","z",0,0,0,0,0,0,

/* 0x40-0x4f */
"0","1","2","3","4","5","6","7","8","9",0,0,0,0,0,0,

/* 0x50-0x5f */
"f1","f2","f3","f4","f5","f6","f7","f8","f9","f10","f11","f12",0,0,0,0,

0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0x60-0x6f */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0x70-0x7f */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0x80-0x8f */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0x90-0x9f */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0xa0-0xaf */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0xb0-0xbf */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0xc0-0xcf */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0xd0-0xdf */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,  /* 0xe0-0xef */

/* 0xf0-0xff */
"mouse-left","mouse-right","mouse-middle",
"mouse-wheel-up","mouse-wheel-down",
0,0,0,0,0,0,0,0,0,0,0,

};


static char buf[128];
int Key_Parse(const char *str)
{
   int i,k;
   const char *c;
   char *d;

   k=0;
   for (c=str;*c;)
   {
      d=buf;
      while (*c && *c!='+') *d++=*c++;
      *d=0;
      if (*c=='+')
      {
         if (!strcmp(buf,keym_shift  )) k|=KEYM_SHIFT;
         else
         if (!strcmp(buf,keym_alt    )) k|=KEYM_ALT;
         else
         if (!strcmp(buf,keym_control)) k|=KEYM_CONTROL;
         else
            return 0;
         c++;
      }
   }
   for (i=0;i<256;i++)
      if (keys[i] && !strcmp(keys[i],buf))
         return k|i;
   return 0;
}


const char *Key_Name(int kv)
{
   buf[0]=0;
   if (kv&KEYM_SHIFT  ) { strcat(buf,keym_shift);   strcat(buf,"+"); }
   if (kv&KEYM_ALT    ) { strcat(buf,keym_alt);     strcat(buf,"+"); }
   if (kv&KEYM_CONTROL) { strcat(buf,keym_control); strcat(buf,"+"); }

   kv&=0xff;
   if (keys[kv])
      strcat(buf,keys[kv]);
   else
      strcat(buf,"invalid");
   
   return buf;
}

