#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/stat.h>

#include "fe/sys.h"


int Sys_Exists(const char *fname)
{
   struct stat buf;

   if (!stat(fname,&buf))
      return 1;
   return 0;
}

#ifdef TARGET_MINGW32
/* TODO */
double Sys_Time(void)
{
   return 0;
}
#else

#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

double Sys_Time(void)
{
static int base=-1;
    struct timeval tv;
    struct timezone tz;
    int i;
    
    i=gettimeofday(&tv,&tz);
    if (base==-1) base=tv.tv_sec;
    tv.tv_sec-=base;

    return tv.tv_sec+((double)tv.tv_usec)/1000000.0;
}
#endif


FILE *Sys_OpenFile(const char *name,const char *mode)
{ /* TODO: search in proper places */
	return fopen(name,mode);
}


