/*
entity.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef ENTITY_H
#define ENTITY_H

entity_t *E_New(void);
void E_Free(entity_t *e);

/* free only the contents of e, not e itself */
void E_FreeC(entity_t *e);

void E_Link(entity_t *e);
void E_Unlink(entity_t *e);

/*
Duplicates:
  key
  value
  num_keys
  
  Group

If full==1, sets uid

*/
/* dest==NULL and it will allocate one for you */
entity_t *E_Duplicate(entity_t *dest, const entity_t *source);

int E_Size(const entity_t *e);

void E_Update(entity_t *e);


const char *GetKeyValue(const entity_t *ent,const char *key);
void SetKeyValue(entity_t *ent,const char *key,const char *value);
void RemoveKeyValue(entity_t *ent,const char *key);


int Target_GetStrNum(const char *v);
int Target_GetNum(entity_t *e,const char *key);
int Target_GetLastNum(const char *key);

void E_Edit(int nents,entity_t **ents);

#endif

