#ifndef GROUP_H
#define GROUP_H


/* Low-level functions */
group_t *G_New(void);
void G_Free(group_t *g);
void G_FreeC(group_t *g);

void G_Link(group_t *g);
void G_Unlink(group_t *g);
group_t *G_Duplicate(group_t *dest,group_t *src);

int G_Size(group_t *g);

void G_Update(group_t *g);


void Grp_CreateWorldGroup(void);

/* This will handle dots in names if the parent groups already exist */
map_uid_t Grp_Create(const char *groupname,map_uid_t parent);
map_uid_t Grp_Find(const char *fullname);
void Grp_Delete(map_uid_t grp);

void Grp_Update(void);

map_uid_t FindVisGroup(map_uid_t first);
map_uid_t GetDefaultGroup(void);

#endif

