#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "status.h"

#include "config.h"
#include "ql.h"


config_var_t
	*cv_debug,

	*cv_cam_pan_speed,
	*cv_cam_zoom_speed,
	*cv_cam_turn_frames,

	*cv_render_flags,

	*cv_edit_snap_size,

	*cv_texture_current,

	*cv_texture_align_rotate,
	*cv_texture_align_shiftx,
	*cv_texture_align_shifty,
	*cv_texture_align_scalex,
	*cv_texture_align_scaley

	;


int
	c_texture_locking;


void Status_Init(void)
{
	cv_debug=Cfg_DefVar(config_quest,
		"debug","0",
		"Activate debug mode.");

	cv_cam_pan_speed=Cfg_DefVar(config_quest,
		"cam.pan_speed","10",
		"Movement speed in viewports.");
	cv_cam_zoom_speed=Cfg_DefVar(config_quest,
		"cam.zoom_speed","1.1",
		"Zooming speed in viewports.");
	cv_cam_turn_frames=Cfg_DefVar(config_quest,
		"cam.turn_frames","10",
		"Number of frames rendered when turning in axis-aligned mode.");

	cv_render_flags=Cfg_DefVar(config_quest,
		"render.flags","0x70e",
		"Flags that control what is rendered.");

	cv_edit_snap_size=Cfg_DefVar(config_quest,
		"edit.snap_size","16",
		"The size of the grid everything is snapped to.");

	cv_texture_current=Cfg_DefVar(config_quest,
		"texture.current",DEFAULT_TEXTURE,
		"The current texture.");

	cv_texture_align_rotate=Cfg_DefVar(config_quest,"texture.align.rotate","0"  ,"Default alignment properties.");
	cv_texture_align_shiftx=Cfg_DefVar(config_quest,"texture.align.shiftx","0"  ,"Default alignment properties.");
	cv_texture_align_shifty=Cfg_DefVar(config_quest,"texture.align.shifty","0"  ,"Default alignment properties.");
	cv_texture_align_scalex=Cfg_DefVar(config_quest,"texture.align.scalex","1.0","Default alignment properties.");
	cv_texture_align_scaley=Cfg_DefVar(config_quest,"texture.align.scaley","1.0","Default alignment properties.");

	c_texture_locking=0;
}

